---
title: Introduction to progressive web apps
slug: Web/Progressive_web_apps/Introduction
tags:
  - Applications
  - Guide
  - Intermediate
  - Introduction
  - PWA
  - Progressive web apps
  - Service Worker
  - js13kGames
  - progressive
  - web manifest
---
<div>{{NextMenu("Web/Progressive_web_apps/App_structure", "Web/Progressive_web_apps")}}</div>

<p class="summary"><span class="seoSummary">This article provides an introduction to Progressive Web Apps (PWAs), discussing what they are and the advantages they offer over regular web apps.</span></p>

<h2 id="What_is_a_Progressive_Web_App">What is a Progressive Web App?</h2>

<div class="callout-box">The term "Progressive Web App" isn't a formal or official name. It's just a shorthand used initially by Google for the concept of creating a flexible, adaptable app using only web technologies.</div>

<p>PWAs are web apps developed using a number of specific technologies and standard patterns to allow them to take advantage of both web and native app features. For example, web apps are more discoverable than native apps; it's a lot easier and faster to visit a website than to install an application, and you can also share web apps by sending a link.</p>

<p>On the other hand, native apps are better integrated with the operating system and therefore offer a more seamless experience for the users. You can install a native app so that it works offline, and users love tapping their icons to easily access their favorite apps, rather than navigating to it using a browser.</p>

<p>PWAs give us the ability to create web apps that can enjoy these same advantages.</p>

<p>It's not a brand new concept—such ideas have been revisited many times on the web platform with various approaches in the past. Progressive Enhancement and responsive design already allow us to build mobile friendly websites.</p>

<p>PWAs, however, provide all this and more without losing any of the existing features that make the web great.</p>

<h2 id="What_makes_an_app_a_PWA">What makes an app a PWA?</h2>

<p>As we hinted at above, PWAs are not created with a single technology. They represent a new philosophy for building web apps, involving some specific patterns, APIs, and other features. It's not that obvious if a web app is a PWA or not from first glance. An app could be considered a PWA when it meets certain requirements, or implements a set of given features: works offline, is installable, is easy to synchronize, can send push notifications, etc.</p>

<p>In addition, there are tools to measure how complete (as a percentage) a web app is, such as <a href="https://developers.google.com/web/tools/lighthouse/">Lighthouse</a>. By implementing various technological advantages, we can make an app more progressive, thus ending up with a higher Lighthouse score. But this is only a rough indicator.</p>

<p>There are some key principles a web app should try to observe to be identified as a PWA. It should be:</p>

<ul>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Discoverable">Discoverable</a>, so the contents can be found through search engines.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Installable">Installable</a>, so it can be available on the device's home screen or app launcher.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Linkable">Linkable</a>, so you can share it by sending a URL.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Network_independent">Network independent</a>, so it works offline or with a poor network connection.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Progressive">Progressive</a>, so it's still usable on a basic level on older browsers, but fully-functional on the latest ones.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Re-engageable">Re-engageable</a>, so it's able to send notifications whenever there's new content available.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Responsive">Responsive</a>, so it's usable on any device with a screen and a browser—mobile phones, tablets, laptops, TVs, refrigerators, etc.</li>
	<li><a href="/en-US/docs/Web/Progressive_web_apps/Advantages#Safe">Safe</a>, so the connections between the user, the app, and your server are secured against any third parties trying to get access to sensitive data.</li>
</ul>

<p>Offering these features and making use of all the {{anch("Advantages of web applications", "advantages")}} offered by web applications can create a compelling, highly flexible offering for your users and customers.</p>

<h3 id="Is_it_worth_doing_all_that">Is it worth doing all that?</h3>

<p>Absolutely! With a relatively small amount of effort required to implement the core PWA features, the benefits are huge. For example:</p>

<ul>
	<li>A decrease in loading times after the app has been installed, thanks to caching with <a href="/en-US/docs/Web/API/Service_Worker_API">service workers</a>, along with saving precious bandwidth and time. PWAs have near-instantaneous loading (from the second visit).</li>
	<li>The ability to update only the content that has changed when an app update is available. In contrast, with a native app, even the slightest modification can force the user to download the entire application again.</li>
	<li>A look and feel that is more integrated with the native platform—app icons on the home screen or app launcher, applications that automatically run in full screen mode, etc.</li>
	<li>Re-engaging with users through the use of system notifications and push messages, leading to more engaged users and better conversion rates.</li>
</ul>

<h3 id="Success_stories">Success stories</h3>

<p>There are many success stories of companies trying the PWA route, opting for an enhanced website experience rather than a native app, and seeing significant measurable benefits as a result. The website <a href="https://www.pwastats.com/"> PWA Stats</a> shares many case studies that indicate these benefits.</p>

<p>The best-known success story is probably that of <a href="https://stories.flipkart.com/introducing-flipkart-lite/"> Flipkart Lite</a>. India's largest e-commerce site was rebuilt as a progressive web app in 2015, which resulted in 70% increase in conversions. The<a href="https://m.aliexpress.com/"> AliExpress</a> PWA has also seen much better results than either the web or the native app, with a 104% increase in conversion rates for new users. Given their profit increase, and the relatively low amount of work required for the conversion of these apps to PWAs, the advantage is clear.</p>

<p>Early stage emerging startups like <a href="https://www.couponmoto.com/"> couponmoto</a> have also started using progressive web apps to drive more consumer engagement, showing that they can help small as well as big companies to (re-)engage users more effectively.</p>

<p>You can check the list at <a href="https://pwa.rocks/"> pwa.rocks</a> for more examples. Particularly worth mentioning is the<a href="https://hnpwa.com/"> hnpwa.com</a> page—this lists an example implementation of the Hacker News website (instead of the usual TodoMVC app), in which you can see the use of various front-end frameworks.</p>

<p>You can even generate PWAs online using the<a href="https://www.pwabuilder.com/"> PWABuilder</a> website.</p>

<p>For service worker and push specific information, be sure to check the<a href="https://serviceworke.rs/"> Service Worker Cookbook</a>, a collection of recipes using service workers in modern sites.</p>

<p>It's well worth trying out a PWA approach, so you can see for yourself if it works for your app.</p>

<h2 id="Advantages_of_web_applications">Advantages of web applications</h2>

<p>A fully-capable progressive web application should provide all of the following advantages to the user.</p>

<h3 id="Discoverability">Discoverability</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12654/discoverable.svg" style="float: left; height: 60px; margin-right: 1em; width: 50px;">The eventual aim is that web apps should have better representation in search engines, be easier to expose, catalog and rank, and have metadata usable by browsers to give them special capabilities.</p>

<p>Some of the capabilities have already been enabled on certain web-based platforms by proprietary technologies like <a href="http://ogp.me/">Open Graph</a>, which provides a format for specifying similar metadata in the {{Glossary("HTML")}} {{HTMLElement("head")}} block using {{HTMLElement("meta")}} tags.</p>

<p>The relevant web standard here is the <a href="/en-US/docs/Web/Manifest">Web app manifest</a>, which defines features of an app such as name, icon, splash screen, and theme colors in a {{Glossary("JSON")}}-formatted manifest file. This is for use in contexts such as app listings and device home screens.</p>

<h3 id="Installability">Installability</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12656/installable.svg" style="float: left; height: 60px; margin-right: 1em; width: 60px;"></p>

<p>A core part of the web app experience is for users to have app icons on their home screen, and be able to tap to open apps into their own native container that feels nicely integrated with the underlying platform.</p>

<p>Modern web apps can have this native app feel via properties set inside the Web app manifest, and via a feature available in modern smartphone browsers called <a href="/en-US/docs/Web/Progressive_web_apps/Developer_guide/Installing">web app installation</a>.</p>

<h3 id="Linkability">Linkability</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12658/linkable.svg" style="float: left; height: 60px; margin-right: 1em; width: 60px;"></p>

<p>One of the most powerful features of the web is the ability to link to an app at a specific URL without the need for an app store or complex installation process. This is how it has always been.</p>

<h3 id="Network_independence">Network independence</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12660/network-independent.svg" style="float: left; height: 60px; margin-right: 1em; width: 60px;"></p>

<p>Modern web apps can work when the network is unreliable, or even non-existent. The basic ideas behind network independence are to be able to:</p>

<ul>
	<li>Revisit a site and get its contents even if no network is available.</li>
	<li>Browse any kind of content the user has previously visited at least once, even under situations of poor connectivity.</li>
	<li>Control what is shown to the user in situations where there is no connectivity.</li>
</ul>

<p>This is achieved using a combination of technologies: <a href="/en-US/docs/Web/API/Service_Worker_API">Service Workers</a> to control page requests (for example storing them offline), the <a href="/en-US/docs/Web/API/Cache">Cache API</a> for storing responses to network requests offline (very useful for storing site assets), and client-side data storage technologies such as <a href="/en-US/docs/Web/API/Web_Storage_API">Web Storage</a> and <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a> to store application data offline.</p>

<h3 id="Progressive_enhancement_support">Progressive enhancement support</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12662/progressive.svg" style="float: left; height: 60px; margin-right: 1em; width: 60px;"></p>

<p>Modern web apps can be developed to provide an excellent experience to fully capable browsers, and an acceptable (although not quite as shiny) experience to less capable browsers. We've been doing this for years with best practices such as progressive enhancement. By using <a href="/en-US/docs/Glossary/Progressive_Enhancement">progressive enhancement</a>, PWAs are cross-browser. This means developers should take into account the differences in implementation of some PWA features and technologies between different browser implementations.</p>

<h3 id="Re-engageability">Re-engageability</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12666/re-engageable.svg" style="float: left; height: 60px; margin-right: 1em; width: 60px;"></p>

<p>One major advantage of native platforms is the ease with which users can be re-engaged by updates and new content, even when they aren't looking at the app or using their devices. Modern web apps can now do this too, using new technologies such as Service Workers for controlling pages, the <a href="/en-US/docs/Web/API/Push_API">Web Push API</a> for sending updates straight from server to app via a service worker, and the <a href="/en-US/docs/Web/API/Notifications_API">Notifications API</a> for generating system notifications to help engage users when they're not actively using their web browser.</p>

<h3 id="Responsiveness">Responsiveness</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12650/responsive.svg" style="float: left; height: 61px; margin-right: 1em; width: 60px;"></p>

<p>Responsive web apps use technologies like <a href="/en-US/docs/Web/CSS/Media_Queries">media queries</a> and <a href="/en-US/docs/Glossary/Viewport">viewport</a> to make sure that their UIs will fit any form factor: desktop, mobile, tablet, or whatever comes next.</p>

<h3 id="Safety">Safety</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/12664/safe.svg" style="float: left; height: 74px; margin-right: 1em; width: 60px;"></p>

<p><img alt='Screenshot showing a huge number of results upon searching for "Messenger" when trying to find Facebook Messenger. Which is the right one?' src="https://mdn.mozillademos.org/files/17175/InstalingMessengerSoManyOptionsEek.jpeg" style="border-style: solid; border-width: 1px; float: right; height: 267px; margin-left: 1em; width: 130px;">The web platform provides a secure delivery mechanism that prevents snooping while simultaneously ensuring that content hasn’t been tampered with, as long as you take advantage of {{Glossary("HTTPS")}} and develop your apps with security in mind.</p>

<p>It's also easy for users to ensure that they're installing the right app, because its URL will match your site's domain. This is very different from apps in app stores, which may have a number of similarly-named apps, some of which may even be based on your own site, which only adds to the confusion. Web apps eliminate that confusion and ensure that users get the best possible experience.</p>

<h2 id="Browser_support">Browser support</h2>

<p>As mentioned before, PWAs don't depend on a single API, but rather using various technologies to achieve the goal of delivering the best web experience possible.</p>

<p>The key ingredient required for PWAs is <a href="/en-US/docs/Web/API/Service_Worker_API"> service worker</a> support. Thankfully service workers are <a href="https://jakearchibald.github.io/isserviceworkerready/"> now supported on all major browsers</a> on desktop and mobile.</p>

<p>Other features such as<a href="/en-US/docs/Web/Manifest"> Web App Manifest</a>,<a href="/en-US/docs/Web/API/Push_API"> Push</a> <a href="/en-US/docs/Web/API/Notifications_API">Notifications</a>, and<a href="/en-US/docs/Web/Progressive_web_apps/Add_to_home_screen"> Add to Home Screen</a> functionality have wide support too. Currently, Safari has limited support for Web App Manifest and Add to Home Screen and no support for web push notifications. However, other major browsers support all these features.</p>

<p>Above all you should follow the progressive enhancement rule: use technologies that enhance the appearance and utility of your app when they're available, but still offer the basic functionality of your app when those features are unavailable. Presenting a trusted website with a good performance is a consequence of using these enhancements; this in turn means building web apps which follow better practices. This way everybody will be able to use the app, but those with modern browsers will benefit from PWA features even more.</p>

<h2 id="An_example_application">An example application</h2>

<p>In this series of articles we will examine the source code of a super simple website that lists information about games submitted to the <a href="http://js13kgames.com/aframe">A-Frame category</a> in the <a href="http://2017.js13kgames.com/">js13kGames 2017</a> competition. You don't have to think about what the actual content on the website is; the main point is to learn how to use PWA features in your own projects.</p>

<p>You can <a href="https://mdn.github.io/pwa-examples/js13kpwa/">see this app in action</a> online, and the source code is <a href="https://github.com/mdn/pwa-examples/tree/master/js13kpwa">available on GitHub</a>. We'll be examining this code carefully over the course of this series of articles.</p>

<p>For now, let's move to the second part of this series, where we’ll be looking at the structure of our example app.</p>

<p>{{NextMenu("Web/Progressive_web_apps/App_structure", "Web/Progressive_web_apps")}}</p>

<div>{{QuickLinksWithSubpages("/en-US/docs/Web/Progressive_web_apps/")}}</div>
